require 'ffi'

module Windows
  module File
    module Constants
      FILE_ATTRIBUTE_NORMAL = 0x00000080
      FILE_ATTRIBUTE_REPARSE_POINT = 0x00000400
      FILE_FLAG_BACKUP_SEMANTICS = 0x02000000
      FILE_FLAG_OPEN_REPARSE_POINT = 0x00200000

      FILE_SHARE_READ  = 1
      FILE_SHARE_WRITE = 2

      FILE_WRITE_ATTRIBUTES = 256

      FILE_TYPE_UNKNOWN = 0x0000
      FILE_TYPE_CHAR    = 0x0002
      NO_ERROR = 0

      GENERIC_READ  = 0x80000000
      GENERIC_WRITE = 0x40000000

      INVALID_HANDLE_VALUE = (1 << FFI::Platform::ADDRESS_SIZE) - 1
      INVALID_FILE_ATTRIBUTES = (1 << FFI::Platform::ADDRESS_SIZE) - 1
      IO_REPARSE_TAG_SYMLINK = 0xA000000C
      OPEN_EXISTING = 3

      DRIVE_REMOVABLE = 2
      DRIVE_CDROM     = 5
      DRIVE_RAMDISK   = 6
    end
  end
end
